% La fonction "fluct_hist" répond à la question 3 de l'exercice 3.
function fluct_hist (a, b, k, x, N)
% On récupère la taille "n" du vecteur x passé en argument par
% l'utilisateur.
n = size (x, 2);
% "classes(i)" va compter combien de simulations sont tombées dans la
% i-ième classe délimitée par les entrées de x.
classes = zeros (1, n - 1);
% On lance une boucle de Monte-Carlo pour compter combien de simulations de
% (b - b-chapeau) tombent dans chaque classe. La fonction "simuler_fluct"
% (non écrite) sert à simuler une réalisation "f" de (b - bchapeau).
for i = 1: N
    f = simuler_fluct (a, b, k);
    % Il faut déterminer dans quelle classe on tombe. Noter qu'il faudrait
    % aussi prévoir le cas où on serait au-delà des valeurs extrêmes de
    % x... Ainsi, il ne faut rien faire si f est plus petite que la plus
    % petite entrée de x.
    if f < x(1)
    else
        % On détermine la classe de f en passant en revue les différentes
        % entrées de x jusqu'à dépasser la valeur de f (ou à avoir épuisé
        % tous les cas).
        for j = 1: n - 1
            if f < x(j + 1)
                % On met à jour la classe concernée et on quitte la boucle.
                classes(j) = classes(j) + 1;
                break
            end
        end
    end
end
% Tracé de l'histogramme. J'ai délibérément refusé d'utiliser la fonction
% "hist" de Matlab, car celle-ci ne permet pas d'utiliser des classes de
% longueurs inégales.
figure;
hold on
for i = 1 : n - 1
    % Matlab refuse de tracer des rectangles de taille nulle; il faut donc
    % exclure ce cas.
    if classes(i) > 0
        % La hauteur du rectangle au-dessus du segment [x(i),x(i+1)] est la
        % densité moyenne de la loi sur cet intervalle, appelée "densite".
        % C'est important, d'une part pour avoir un axe des ordonnées
        % significatif (dont les valeurs ne changent pas, par exemple,
        % quand on modifie le nombre de classes), et d'autre part pour
        % pouvoir traiter le cas de classes de largeurs différentes.
        densite = classes (i) / N / (x(i + 1) - x(i));
        % La syntaxe de la fonction "rectangle" de Matlab est un peu tordue
        % : la ligne ci-dessous trace un rectangle bleu de hauteur densite
        % s'appuyant sur [x(i),x(i+1)].
        rectangle ('Position', [x(i), 0, x(i + 1) - x(i), densite], ...
            'FaceColor', 'b');
    end
end
hold off
return
end

function fluct = simuler_fluct (a, b, k)
x = a + (b - a) * rand (1, k);
xmin = min (x);
xmax = max (x);
b_est = xmax + (xmax - xmin) / (k - 1);
fluct = b - b_est;
return
end